#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами

#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON_START 5 // Назначение пина, к которому подключена тактовая кнопка запуска/останова
#define LINE_SENSOR 13 // Назначение пина, к которому подключен датчик линии
#define RIGHT_BUMP 9 // Назначение пина, к которому подключен правый концевой выключатель
#define LEFT_BUMP 10 // Назначение пина, к которому подключен левый концевой выключатель

bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false
bool sensor_state; // Объявление переменной sensor_state
bool button_state; // Объявление переменной button_state

int speeds=100; // Б.1 - Объявление переменной speeds и присвоение ей значения 100
int counter; // Объявление переменной counter
int timer; // Объявление переменной timer 

void button_read(); // Объявление функции button_read()
void zapusk(); // Объявление функции zapusk()
void backward_go(); // Объявление функции backward_go()
void turn_right(); // Объявление функции turn_right()
void turn_left(); // Объявление функции turn_left()

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left
DCMotor* kosilka; // Инициализация мотора и присвоение ему имени kosilka

void setup() {
Board::vertor_PCA(); // Объявление типа используемого контроллера - vertor_PCA

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5
kosilka = new DCMotor(2, 0, false, 5); // Настройка мотора kosilka с применением функции DCMotor(a, b, c, d): подключен к клеммнику 2, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left
kosilka->stop(false); // Команда на остановку вращения мотора motor_left

pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode (BUTTON_START,INPUT); // Настройка пина BUTTON_START на ввод
pinMode (LINE_SENSOR,INPUT); // Настройка пина LINE_SENSOR на ввод
pinMode (RIGHT_BUMP,INPUT); // Настройка пина RIGHT_BUMP на ввод
pinMode (LEFT_BUMP,INPUT); // Настройка пина LEFT_BUMP на ввод
}

void loop() {      
  button_read(); // Б.2 - Вызов на исполнение функции button_read
  if(robot_state==true) // Б.3 - Если значение переменной robot_state равно true, то начать выполнение инструкций в скобках
  {   
  zapusk(); // Б.4 - Вызов на исполнение функции zapusk    
  while(robot_state==true) // Б.5 - Выполнение инструкций в скобках пока значение переменной robot_state равно true     
  {
     sensor_state=digitalRead(LINE_SENSOR); // Б.6 - Сохранение состояния на пине LINE_SENSOR в переменную sensor_state
     if(sensor_state==true) // Б.7 - Если значение переменной sensor_state равно true, то
     {
      motor_right->forward(speeds); // Б.9 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
      motor_left->forward(speeds); // Б.9 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
      sensor_state=digitalRead(RIGHT_BUMP); // Б.10 - Сохранение состояния на пине RIGHT_BUMP в переменную sensor_state
      if(sensor_state==true) // Б.11 - Если значение переменной sensor_state равно true (правый концевой выключатель нажат)
      {
        turn_left(); // Б.12 - Вызов функции для выполнения объезда препятствия слева
      }
      sensor_state=digitalRead(LEFT_BUMP); // Б.13 - Сохранение состояния на пине LEFT_BUMP в переменную sensor_state
      if(sensor_state==true) // Б.14 - Если значение переменной sensor_state равно true (левый концевой выключатель нажат)
      {
        turn_right(); // Б.15 - Вызов функции для выполнения объезда препятствия справа
      }
     }
     else // Иначе значение переменной равно false (под датчиком линии черный цвет)
     {      
      backward_go(); // Б.8 - Передача управления функции backward_go, реализующей движение назад и разворот робота
     }
     button_state=digitalRead(BUTTON_START); // Б.16 - Сохранение состояния на пине BUTTON_START в переменную button_state
     if(button_state==0) // Б.17 - Если значение переменной button_state равно 0, то 
     {
      robot_state=false; // Б.18 - Присвоение переменной robot_state значение false 
      motor_right->stop(false); // Б.19 - Команда на остановку вращения мотора motor_right
      motor_left->stop(false); // Б.19 - Команда на остановку вращения мотора motor_left      
      kosilka->stop(false); // Б.20 - Команда на остановку вращения мотора kosilka   
      delay(1500); // Б.21 - Ожидание 1,5 секунд
     }     
  }
  }
}

void button_read()
{
  button_state=digitalRead(BUTTON_START); // Б.2.1 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.2 - Если значение переменной button_state равно 0, то 
  {
  delay(10); // Б.2.3 - Ожидание 0,01 с
  button_state=digitalRead(BUTTON_START); // Б.2.4 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.5 - Если значение переменной button_state равно 0, то 
  {
  do 
  {
   button_state=digitalRead(BUTTON_START); // Б.2.6 - Сохранение состояния на пине BUTTON_START в переменную button_state
  }
  while(button_state==0); // Б.2.7 - Цикл do..while() выполнять до тех пор, пока значение переменной button_state равно 0
   robot_state=true; // Б.2.8 - Присвоение переменной robot_state значение true   
  }
  }
}

void zapusk()
{
  counter=0; // Б.4.1 - Присвоение переменной counter значения 0
  while(counter<3) // Б.4.2 - Инициализация цикла While()
                   // Выполнение цикла, пока значение переменной counter меньше 3                                     
  {
   digitalWrite(LEFT_LED,HIGH); // Б.4.3 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
   digitalWrite(RIGHT_LED,HIGH); // Б.4.3 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
   delay(500); // Б.4.4 - Ожидание 0,5 секунды
   digitalWrite(LEFT_LED,LOW); // Б.4.5 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
   digitalWrite(RIGHT_LED,LOW); // Б.4.5 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
   delay(500); // Б.4.6 - Ожидание 0,5 секунд
   counter=counter+1; // Б.4.7 - Увеличение значения переменной counter на 1
  }  
   kosilka->forward(speeds); // Б.4.8 - Команда на запуск мотора kosilka со скоростью speeds % в прямом направлении
   delay(500); // Б.4.9 - Ожидание 0,5 с      
}

void backward_go()
{
  motor_right->stop(false); // Б.8.1 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.8.1 - Команда на остановку вращения мотора motor_left      
  motor_right->backward(speeds); // Б.8.2 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->backward(speeds); // Б.8.2 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении
  delay(600); // Б.8.3 - Ожидание 0,6 секунд
  motor_right->backward(speeds); // Б.8.4 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->forward(speeds); // Б.8.4 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
  timer=rand()%50+51; // Б.8.5 - Присвоение переменной timer случайного значения от 50 до 100      
  while (timer>0) // Б.8.6 - Цикл While(). Выполнять до тех пор, пока истинно выражение timer>0
  {
    delay(10); // Б.8.7 - Ожидание 0,01 секунды       
    sensor_state=digitalRead(LINE_SENSOR); // Б.8.8 - Сохранение состояния на пине LINE_SENSOR в переменную sensor_state
    if(sensor_state==false)  // Б.8.9 - Если значение переменной button_state равно true, то
    {
      motor_right->backward(speeds); // Б.8.10 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
      motor_left->backward(speeds); // Б.8.10 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении
      delay(600); // Б.8.11 - Ожидание 0,6 секунд
      break; // Команда на прерывание цикла разворота робота
    } 
      timer=timer-1; // Б.8.13 - Уменьшение значения переменной timer на 1       
    }
     motor_right->stop(false); // Б.8.12 - Команда на остановку вращения мотора motor_right
     motor_left->stop(false); // Б.8.12 - Команда на остановку вращения мотора motor_left   
}

void turn_left()
{
  motor_right->stop(false); // Б.12.1 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.12.1 - Команда на остановку вращения мотора motor_left 
  motor_right->backward(speeds); // Б.12.2 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->backward(speeds); // Б.12.2 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении      
  delay(800); // Б.12.3 - Ожидание 0,8 секунды
  motor_right->forward(speeds); // Б.12.4 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
  motor_left->backward(speeds); // Б.12.4 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении
  delay(1000); // Б.12.5 - Ожидание 1 секунду
  motor_right->forward(speeds); // Б.12.6 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
  motor_left->forward(speeds); // Б.12.6 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
  delay(800); // Б.12.7 - Ожидание 0,8 секунды
  motor_right->backward(speeds); // Б.12.8 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->forward(speeds); // Б.12.8 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
  delay(1000); // Б.12.9 - Ожидание 1 секунду
  motor_right->stop(false); // Б.12.10 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.12.10 - Команда на остановку вращения мотора motor_left 
}

void turn_right()
{
  motor_right->stop(false); // Б.15.1 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.15.1 - Команда на остановку вращения мотора motor_left 
  motor_right->backward(speeds); // Б.15.2 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->backward(speeds); // Б.15.2 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении      
  delay(800); // Б.15.3 - Ожидание 0,8 секунды 
  motor_right->backward(speeds); // Б.15.4 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->forward(speeds); // Б.15.4 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
  delay(1000); // Б.15.5 - Ожидание 1 секунду 
  motor_right->forward(speeds); // Б.15.6 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
  motor_left->forward(speeds); // Б.15.6 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
  delay(800); // Б.15.7 - Ожидание 0,8 секунды
  motor_right->forward(speeds); // Б.15.8 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
  motor_left->backward(speeds); // Б.15.8 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении
  delay(1000); // Б.15.9 - Ожидание 1 секунду
  motor_right->stop(false); // Б.15.10 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.15.10 - Команда на остановку вращения мотора motor_left 
}
